<?php
include '../serverConfig.php';

require_once("Classes/PHPExcel.php");
require_once("Classes/PHPExcel/Writer/Excel2007.php");

//creates a new excel 
$objPHPExcel = new PHPExcel();

//some information about autorship
$objPHPExcel->getProperties()->setCreator("Marcos Juayek");
$objPHPExcel->getProperties()->setLastModifiedBy("mjuayek@correo.um.edu.uy");
$objPHPExcel->getProperties()->setTitle("VQI");
$objPHPExcel->getProperties()->setSubject("Subjective Tests");
$objPHPExcel->getProperties()->setDescription("Results of the Subjective Tests");

//connection to the database
$link = mysqli_connect($mysql_server, $mysql_user, $mysql_pass, $mysql_db_name);
if (!$link) {
    die('connection refused: ' . mysqli_connect_error() . PHP_EOL);
}

//----Sessions----

//obtains the sessions
$sesiones=mysqli_query($link, "SELECT * FROM sessions");

//work with the main active sheet
$objPHPExcel->setActiveSheetIndex(0);
//tab title
$objPHPExcel->getActiveSheet()->setTitle('Sessions');

//adds the titles of the columns
$objPHPExcel->getActiveSheet()->SetCellValue("A1", 'idSession');
$objPHPExcel->getActiveSheet()->setCellValue("B1", 'numbPart');
$objPHPExcel->getActiveSheet()->SetCellValue("C1", 'sessionDate');
$objPHPExcel->getActiveSheet()->setCellValue("D1", 'description');
$objPHPExcel->getActiveSheet()->setCellValue("E1", 'active');
$objPHPExcel->getActiveSheet()->setCellValue("F1", 'ready');

//iterates for the results
$i = 2;
while($row=mysqli_fetch_array($sesiones, MYSQLI_ASSOC)){
    $objPHPExcel->getActiveSheet()->SetCellValue("A$i", $row['idSession']);
    $objPHPExcel->getActiveSheet()->SetCellValue("B$i", $row['numbPart']);
    $objPHPExcel->getActiveSheet()->setCellValue("C$i", $row['sessionDate']);
    $objPHPExcel->getActiveSheet()->setCellValue("D$i", $row['description']);
	$objPHPExcel->getActiveSheet()->setCellValue("E$i", $row['active']);
	$objPHPExcel->getActiveSheet()->setCellValue("F$i", $row['ready']);
	$i++;
}

//--------Videos----------
 
$objPHPExcel->createSheet(1);
$objPHPExcel->setActiveSheetIndex(1);

$objPHPExcel->getActiveSheet()->setTitle('Videos');

$videos=mysqli_query($link, "SELECT * FROM videos");

$objPHPExcel->getActiveSheet()->SetCellValue("A1", 'idVideo');
$objPHPExcel->getActiveSheet()->SetCellValue("B1", 'name');
$objPHPExcel->getActiveSheet()->setCellValue("C1", 'description');
$objPHPExcel->getActiveSheet()->setCellValue("D1", 'source');
$objPHPExcel->getActiveSheet()->setCellValue("E1", 'codec');
$objPHPExcel->getActiveSheet()->setCellValue("F1", 'resolution');
$objPHPExcel->getActiveSheet()->setCellValue("G1", 'bitRate');
$objPHPExcel->getActiveSheet()->setCellValue("H1", 'frameRate');
$objPHPExcel->getActiveSheet()->setCellValue("I1", 'numBursts');
$objPHPExcel->getActiveSheet()->setCellValue("J1", 'durBursts');
$objPHPExcel->getActiveSheet()->setCellValue("K1", 'packetLoss');
$objPHPExcel->getActiveSheet()->setCellValue("L1", 'enable');

$i = 2;
while($row=mysqli_fetch_array($videos, MYSQLI_ASSOC)){
    $objPHPExcel->getActiveSheet()->SetCellValue("A$i", $row['idVideo']);
    $objPHPExcel->getActiveSheet()->SetCellValue("B$i", $row['name']);
    $objPHPExcel->getActiveSheet()->setCellValue("C$i", $row['description']);
    $objPHPExcel->getActiveSheet()->setCellValue("D$i", $row['source']);
	$objPHPExcel->getActiveSheet()->setCellValue("E$i", $row['codec']);
	$objPHPExcel->getActiveSheet()->setCellValue("F$i", $row['resolution']);
	$objPHPExcel->getActiveSheet()->setCellValue("G$i", $row['bitRate']);
	$objPHPExcel->getActiveSheet()->setCellValue("H$i", $row['frameRate']);
	$objPHPExcel->getActiveSheet()->setCellValue("I$i", $row['numBursts']);
	$objPHPExcel->getActiveSheet()->setCellValue("J$i", $row['durBursts']);
	$objPHPExcel->getActiveSheet()->setCellValue("K$i", $row['packetLoss']);
	$objPHPExcel->getActiveSheet()->setCellValue("L$i", $row['enable']);
	$i++;
}

//--------Videos x sesion----------
 
$objPHPExcel->createSheet(2);
$objPHPExcel->setActiveSheetIndex(2);

$objPHPExcel->getActiveSheet()->setTitle('Videos per Session');
 
$videosPorSesion=mysqli_query($link, "SELECT sessions.idSession, sessions.sessionDate, videos.idVideo, videos.name FROM sessionvideos INNER JOIN sessions ON sessions.idSession=sessionvideos.idSession INNER JOIN videos ON videos.idVideo=sessionvideos.idVideo");

$objPHPExcel->getActiveSheet()->SetCellValue("A1", 'idSession');
$objPHPExcel->getActiveSheet()->SetCellValue("B1", 'sessionDate');
$objPHPExcel->getActiveSheet()->setCellValue("C1", 'idVideo');
$objPHPExcel->getActiveSheet()->setCellValue("D1", 'name');	

$i = 2;
while($row=mysqli_fetch_array($videosPorSesion, MYSQLI_ASSOC)){
    $objPHPExcel->getActiveSheet()->SetCellValue("A$i", $row['idSession']);
    $objPHPExcel->getActiveSheet()->SetCellValue("B$i", $row['sessionDate']);
    $objPHPExcel->getActiveSheet()->setCellValue("C$i", $row['idVideo']);
    $objPHPExcel->getActiveSheet()->setCellValue("D$i", $row['name']);
	$i++;
}

//--------Users----------
 
$objPHPExcel->createSheet(3);
$objPHPExcel->setActiveSheetIndex(3);

$objPHPExcel->getActiveSheet()->setTitle('Users');

$user=mysqli_query($link, "SELECT * FROM users");

$objPHPExcel->getActiveSheet()->SetCellValue("A1", 'idUser');
$objPHPExcel->getActiveSheet()->SetCellValue("B1", 'sex');
$objPHPExcel->getActiveSheet()->setCellValue("C1", 'age');
$objPHPExcel->getActiveSheet()->setCellValue("D1", 'educationLevel');
$objPHPExcel->getActiveSheet()->setCellValue("E1", 'CellPhone');
$objPHPExcel->getActiveSheet()->setCellValue("F1", 'CellPhoneHours');
$objPHPExcel->getActiveSheet()->setCellValue("G1", 'Tablet');
$objPHPExcel->getActiveSheet()->setCellValue("H1", 'TabletHours');
$objPHPExcel->getActiveSheet()->setCellValue("I1", 'TV');
$objPHPExcel->getActiveSheet()->setCellValue("J1", 'TVHours');
$objPHPExcel->getActiveSheet()->setCellValue("K1", 'PC');
$objPHPExcel->getActiveSheet()->setCellValue("L1", 'PCHours');

$i = 2;
while($row=mysqli_fetch_array($user, MYSQLI_ASSOC)){
    $objPHPExcel->getActiveSheet()->SetCellValue("A$i", $row['idUser']);
    $objPHPExcel->getActiveSheet()->SetCellValue("B$i", $row['sex']);
    $objPHPExcel->getActiveSheet()->setCellValue("C$i", $row['age']);
    $objPHPExcel->getActiveSheet()->setCellValue("D$i", $row['educationLevel']);
	$objPHPExcel->getActiveSheet()->setCellValue("E$i", $row['CellPhone']);	
	$objPHPExcel->getActiveSheet()->setCellValue("F$i", $row['CellPhoneHours']);
	$objPHPExcel->getActiveSheet()->setCellValue("G$i", $row['Tablet']);
	$objPHPExcel->getActiveSheet()->setCellValue("H$i", $row['TabletHours']);
	$objPHPExcel->getActiveSheet()->setCellValue("I$i", $row['TV']);
	$objPHPExcel->getActiveSheet()->setCellValue("J$i", $row['TVHours']);
	$objPHPExcel->getActiveSheet()->setCellValue("K$i", $row['PC']);
	$objPHPExcel->getActiveSheet()->setCellValue("L$i", $row['PCHours']);
	$i++;
}

//--------Users per session ----------
 
$objPHPExcel->createSheet(4);
$objPHPExcel->setActiveSheetIndex(4);

$objPHPExcel->getActiveSheet()->setTitle('Users per Session');
 
$sessionhasuser=mysqli_query($link, "SELECT sessions.idSession, sessions.sessionDate, participants.idUser, participants.position FROM participants INNER JOIN sessions ON sessions.idSession=participants.idSession");

$objPHPExcel->getActiveSheet()->SetCellValue("A1", 'idSession');
$objPHPExcel->getActiveSheet()->SetCellValue("B1", 'sessionDate');	
$objPHPExcel->getActiveSheet()->SetCellValue("C1", 'idUser');
$objPHPExcel->getActiveSheet()->SetCellValue("D1", 'position');

$i = 2;
while($row=mysqli_fetch_array($sessionhasuser, MYSQLI_ASSOC)){
  $objPHPExcel->getActiveSheet()->SetCellValue("A$i", $row['idSession']);
  $objPHPExcel->getActiveSheet()->SetCellValue("B$i", $row['sessionDate']);	
	$objPHPExcel->getActiveSheet()->SetCellValue("C$i", $row['idUser']);	
	$objPHPExcel->getActiveSheet()->SetCellValue("D$i", $row['position']);
	$i++;
}

//--------Rated videos----------
 
$objPHPExcel->createSheet(5);
$objPHPExcel->setActiveSheetIndex(5);

$objPHPExcel->getActiveSheet()->setTitle('Rated Videos');
 
$videoscalificados=mysqli_query($link, "SELECT sessions.idSession, sessions.sessionDate, videos.idVideo, videos.name, ratings.idUser, ratings.MOS FROM ratings INNER JOIN sessions ON sessions.idSession=ratings.idSession INNER JOIN videos ON videos.idVideo=ratings.idVideo INNER JOIN sessionvideos ON sessionvideos.idSession=ratings.idSession AND sessionvideos.idVideo=ratings.idVideo");

$objPHPExcel->getActiveSheet()->SetCellValue("A1", 'idSession');
$objPHPExcel->getActiveSheet()->SetCellValue("B1", 'sessionDate');
$objPHPExcel->getActiveSheet()->setCellValue("C1", 'idVideo');
$objPHPExcel->getActiveSheet()->setCellValue("D1", 'name');
$objPHPExcel->getActiveSheet()->setCellValue("E1", 'idUser');
$objPHPExcel->getActiveSheet()->setCellValue("F1", 'MOS');

$i = 2;
while($row=mysqli_fetch_array($videoscalificados, MYSQLI_ASSOC)){
    $objPHPExcel->getActiveSheet()->SetCellValue("A$i", $row['idSession']);
    $objPHPExcel->getActiveSheet()->SetCellValue("B$i", $row['sessionDate']);
    $objPHPExcel->getActiveSheet()->setCellValue("C$i", $row['idVideo']);
    $objPHPExcel->getActiveSheet()->setCellValue("D$i", $row['name']);
	$objPHPExcel->getActiveSheet()->setCellValue("E$i", $row['idUser']);
	$objPHPExcel->getActiveSheet()->setCellValue("F$i", $row['MOS']);
	$i++;
}
 
//modifies the HTTP headers to indicate that an Excel spreadsheet is being sent
header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
header('Content-Disposition: attachment;filename="subjectiveTests.xlsx"');
header('Cache-Control: max-age=0');

//creates the .xlsx file
$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
$objWriter->save('php://output');

mysqli_close($link);

?>
